USE DFPORT

character*20 scale_line1,scale_line2

character*8 ar,md,line
character*4 dsaa/'DSAA'/
allocatable dv_map(:,:),dv2_map(:,:),v_abs(:,:)
common/pi/pi,per
common/kod_model/kod_abs, kod_anomaly
common/kod_combi/kod_1,kod_2
common/refmod/nref,href(600),vref(600)

common/relief/nrlf,xrlf(10000),yrlf(10000),sea_lev,v_air,v_sea,v_min


common/syn_start/ k_1start_2syn

one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0

open(1,file='../../model.dat')
read(1,'(a8)')ar
read(1,'(a8)')md
close(1)

i=system('mkdir ..\..\DATA\'//ar//'\'//md//'\DATA')


open(1,file='../a_define_model/SET.DAT')
read(1,*)k_1start_2syn
read(1,*)n_micro
close(1)

write(*,*)' ar=',ar,' md=',md


key_preview=0
open(1,file='../../preview_key.txt')
read(1,*,end=771)key_preview
771 close(1)

if(key_preview.ne.0) then
	i=system('mkdir ..\..\PICS\'//ar//'\'//md)
	open(1,file='../../data/'//ar//'/config.txt')
	read(1,*) npix_x,npix_y
	read(1,*)tick_x,tick_y
	read(1,*)scale_line1
	read(1,*)amp_min1,amp_max1
	read(1,*)scale_line2
	read(1,*)amp_min2,amp_max2
	close(1)

	i=system('copy ..\..\COMMON\visual_exe\visual.exe layers.exe')
	i=system('copy ..\..\COMMON\scales_scl\'//scale_line1//' '//scale_line1)
	i=system('copy ..\..\COMMON\scales_scl\'//scale_line2//' '//scale_line2)

end if

call read_ISO_ABS(ar,md)
call read_ISO_ANOM(ar,md)

sea_lev=0
nrlf=0
open(1,file='../../DATA/'//ar//'/inidata/relief.bln',status='old',err=992)
read(1,*,end=92)nrlf,sea_lev,v_air,v_sea,v_min
do irlf=1,nrlf
	read(1,*)xrlf(irlf),yrlf(irlf)
end do
92 close(1)
992 continue

!xxx=451.933675
!yyy=103.869897

!vabs = velocity(xxx,yyy)
!write(*,*)' vabs=',vabs

!pause


!******************************************************************

open(1,file='../../DATA/'//ar//'/set_vis.dat')
read(1,*) xmap1,xmap2,dxmap  
read(1,*) ymap1,ymap2,dymap  
close(1)
write(*,*)' xmap1=',xmap1,' xmap2=',xmap2
write(*,*)' ymap1=',ymap1,' ymap2=',ymap2

dxmap=dxmap/n_micro
dymap=dymap/n_micro

nxmap=int_best((xmap2-xmap1)/dxmap)
nymap=int_best((ymap2-ymap1)/dymap)

allocate(dv_map(nxmap,nymap),dv2_map(nxmap,nymap),v_abs(nxmap,nymap))

write(*,*)' nxmap=',nxmap,' nymap=',nymap

vmax=0
vmin=999999999
open(11,file='../../DATA/'//ar//'/'//md//'/data/vav_syn.bln')
write(11,*)nymap

do iy=1,nymap
	yyy=ymap1+(iy-1)*dymap
	vav=0
	do ix=1,nxmap
		xxx=xmap1+(ix-1)*dxmap


		ysurf = relieff(xxx)
		if(yyy.gt.ysurf) then
			v_abs(ix,iy)=-999
			dv_map(ix,iy)=-999
			vav=vav+v_sea
		else
			v_abs(ix,iy)=velocity(xxx,yyy)

			call SYN_ISO_ANOM(xxx,yyy,dv)
			dv_map(ix,iy)=dv
			!write(*,*)' v_abs=',v_abs(ix,iy)
			vav=vav+v_abs(ix,iy)
		end if

		!v0=vrefmod(yyy)

		if(kod_anomaly.eq.3)then

			if(kod_2.eq.1)then
				call dv_BRD_iso_2(xxx,yyy,dv2)
			else if(kod_2.eq.2)then
				call dv_FREE_iso_2(xxx,yyy,dv2)
			end if

			dv2_map(ix,iy)=dv2

		end if


		if(v_abs(ix,iy).gt.vmax)vmax=v_abs(ix,iy)
		if(v_abs(ix,iy).lt.vmin)vmin=v_abs(ix,iy)
	end do
	vav=vav/nxmap
	write(11,*)vav,yyy
	if(mod(iy,100).eq.0)write(*,*)' yyy=',yyy,' vav=',vav
	!stop
end do
close(11)

open(14,file='../../DATA/'//ar//'/'//md//'/data/dv_ini.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)-999,999
do iy=1,nymap
	write(14,*)(dv_map(ix,iy),ix=1,nxmap)
end do
close(14)

open(14,file='../../FIG_files/syn_mod/dv_ini.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)-999,999
do iy=1,nymap
	write(14,*)(dv_map(ix,iy),ix=1,nxmap)
end do
close(14)

if(kod_anomaly.eq.3)then

open(14,file='../../FIG_files/syn_mod/dv2_ini.grd')
	write(14,'(a4)')dsaa
	write(14,*)nxmap,nymap
	write(14,*)xmap1,xmap2
	write(14,*)ymap1,ymap2
	write(14,*)-999,999
	do iy=1,nymap
		write(14,*)(dv2_map(ix,iy),ix=1,nxmap)
	end do
	close(14)
end if



open(14,file='../../FIG_files/syn_mod/abs_ini.grd')
write(14,'(a4)')dsaa
write(14,*)nxmap,nymap
write(14,*)xmap1,xmap2
write(14,*)ymap1,ymap2
write(14,*)vmin,vmax
do iy=1,nymap
	write(14,*)(v_abs(ix,iy),ix=1,nxmap)
end do
close(14)

if(key_preview.eq.0) stop

!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************

open(14,file='config.txt')
write(14,*)npix_x,npix_y
write(14,*)'_______ Size of the picture in pixels (nx,ny)'
write(14,*)xmap1,xmap2
write(14,*)'_______ Physical coordinates along X (xmin,xmax)'
write(14,*)ymap1,ymap2
write(14,*)'_______ Physical coordinates along Y (ymin,ymax)'
write(14,*)tick_x,tick_y
write(14,*)'_______ Spacing of ticks on axes (dx,dy)'
if(k_1start_2syn.eq.1) then
	write(14,157)ar,md
	157 format('..\..\PICS\',a8,'\',a8,'\start_abs.png')
	write(14,*)'_______ Path of the output picture'
	write(14,3537)	
	3537 format(' Starting model, absolute velocity')
else
	write(14,151)ar,md
	151 format('..\..\PICS\',a8,'\',a8,'\syn_abs.png')
	write(14,*)'_______ Path of the output picture'
	write(14,3532)	
	3532 format(' Synthetic model, absolute velocity')
end if
write(14,*)'_______ Title of the plot on the upper axe'
write(14,*)	1
write(14,*)'_______ Number of layers'

write(14,59)
write(14,*)	1
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,152)
152 format('..\..\FIG_files\syn_mod\abs_ini.grd')
write(14,*)'_______ Location of the GRD file'
write(14,153)scale_line2
153 format(a20)
write(14,*)'_______ Scale for visualization'
write(14,*)	amp_min2,amp_max2
write(14,*)'_______ scale diapason'

write(14,59)
write(14,*)	2
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,54)ar
54 format('..\..\DATA\',a8,'\inidata\relief.bln')
write(14,*)'_______ Location of the BLN file'
write(14,*)	5
write(14,*)'_______ Thickness of line in pixels'
write(14,*)	0,0,0
write(14,*)'_______ RGB color'

close(14)

i=system('layers.exe')

!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************
!**********************************************************

open(14,file='config.txt')
write(14,*)npix_x,npix_y
write(14,*)'_______ Size of the picture in pixels (nx,ny)'
write(14,*)xmap1,xmap2
write(14,*)'_______ Physical coordinates along X (xmin,xmax)'
write(14,*)ymap1,ymap2
write(14,*)'_______ Physical coordinates along Y (ymin,ymax)'
write(14,*)tick_x,tick_y
write(14,*)'_______ Spacing of ticks on axes (dx,dy)'

if(k_1start_2syn.eq.1) then
	write(14,258)ar,md
	258 format('..\..\PICS\',a8,'\',a8,'\start_dv.png')
	write(14,*)'_______ Path of the output picture'
	write(14,3638)	
	3638 format(' Starting model, relative anomalies')
else
	write(14,251)ar,md
	251 format('..\..\PICS\',a8,'\',a8,'\syn_dv.png')
	write(14,*)'_______ Path of the output picture'
	write(14,3632)	
	3632 format(' Synthetic model, relative anomalies')
end if



write(14,*)'_______ Title of the plot on the upper axe'
write(14,*)	1
write(14,*)'_______ Number of layers'

59 format('********************************************')

write(14,59)
write(14,*)	1
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,252)
252 format('..\..\FIG_files\syn_mod\dv_ini.grd')
write(14,*)'_______ Location of the GRD file'
write(14,253)scale_line1
253 format(a20)
write(14,*)'_______ Scale for visualization'
write(14,*)	amp_min1,amp_max1
write(14,*)'_______ scale diapason'

write(14,59)
write(14,*)	2
write(14,*)'_______ Key of the layer (1: contour, 2: line, 3:dots)'
write(14,54)ar
write(14,*)'_______ Location of the BLN file'
write(14,*)	5
write(14,*)'_______ Thickness of line in pixels'
write(14,*)	0,0,0
write(14,*)'_______ RGB color'



close(14)

i=system('layers.exe')


stop
end