subroutine bend_initial(xxx1,yyy1,xxx2,yyy2, tray)

! kod_prev=0: initial shape is from a common block /ray_xyv/
! kod_prev=1: initial shape is a streight line
! kod_prev=2: initial shape is a circle with R to be optimized


common/ray_xyv/nray,xray(10000),yray(10000),vray(10000),sray(10000)
common/param_reg_bend/step,segm_min,bendreg_min,bendreg_max
common/visual/k_prn_circle,k_prn_bend
common/pi/pi,per



real xprev(10000),yprev(10000),vprev(10000),sprev(10000)


real xxray(10000),yyray(10000),vvray(10000),ssray(10000)
real vtmp(10000),smega1(500),smega2(500),bend_mega(500)
real dxray(10000),dyray(10000)
real dxbest(10000),dybest(10000),vbest(10000)
real dxunit(10000),dyunit(10000)
integer nmega1(500),nmega2(500)

dist2depth_ini=3


call streight_line(xxx1,yyy1,xxx2,yyy2, tray)

!write(*,*)' tray=',tray
sray(1)=0
do i=2,nray
	x1=xray(i-1)
	y1=yray(i-1)
	x2=xray(i)
	y2=yray(i)
	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
	sray(i)=sray(i-1)+ds
end do
tray=0
do inod=2,nray
	s1=sray(inod-1)
	s2=sray(inod)
	v1=vray(inod-1)
	v2=vray(inod)
	ds=s2-s1
	vm=(v2+v1)/2.
	tray=tray+ds/vm
	!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
end do
!stop

nprev=nray
tprev=tray
xprev=xray
yprev=yray
vprev=vray
sprev=sray

!if(k_prn_bend.eq.1) open(31,file='../../FIG_files/rays/all_1_arriv.bln')

totdist=sray(nray)
bendini_max=totdist/dist2depth_ini

spart1=0
spart2=totdist
smid=(spart1+spart2)/2.

x1=xprev(1)
y1=yprev(1)
x2=xprev(nprev)
y2=yprev(nprev)

ssegm=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
sign=abs(x2-x1)/(x2-x1)
dxds=(x2-x1)/ssegm
dyds=(y2-y1)/ssegm

dxunit=0
dyunit=0
do inode=1,nprev
	sss=sprev(inode)
	d_value=cos( (pi / (spart2-spart1)) * (sss-smid) )
	dxunit(inode)= - d_value * dyds * sign
	dyunit(inode)=   d_value * dxds * sign
!	write(*,*)' sss=',sss,' d_value=',d_value
end do

nbend_ini=bendini_max/bendreg_max+1
!write(*,*)' bendini_max=',bendini_max,' nbend_ini=',nbend_ini
tmin=tprev

!open(42,file='../../FIG_files/rays/ini_all.bln')

nbest=0
do ibend_ini=1,nbend_ini
	bend_cur=ibend_ini*bendreg_max
	
	xray = xprev - dxunit * bend_cur
	yray = yprev - dyunit * bend_cur

	sray(1)=0
	do i=2,nray
		x1=xray(i-1)
		y1=yray(i-1)
		x2=xray(i)
		y2=yray(i)
		ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
		sray(i)=sray(i-1)+ds
		!write(*,*)sray(i),sprev(i)
	end do

	do i=1,nray
		x=xray(i)
		y=yray(i)
		vray(i)=velocity(x,y)
		!write(*,*)x,y,vray(i)
	end do

	tray=0
	do inod=2,nray
		s1=sray(inod-1)
		s2=sray(inod)
		v1=vray(inod-1)
		v2=vray(inod)
		ds=s2-s1
		vm=(v2+v1)/2.
		tray=tray+ds/vm
		!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
	end do
	!write(*,*)' bend_cur=',bend_cur,' tray=',tray,' tmin=',tmin

!	write(42,*)nray
!	do i=1,nray
!		write(42,*)xray(i),yray(i)
!	end do


	if(tray.lt.tmin) then
		bend_best = bend_cur
		nbest=ibend_ini
		tmin=tray
	end if


end do
!close(42)
!write(*,*)' bend_best=',bend_best,' tmin=',tmin

if(nbest.eq.0) goto 449

!open(42,file='../../FIG_files/rays/ini_all2.bln')

do ibend_ini=1,nbest
	bend_cur=bendreg_max
	spart1=0
	spart2=sprev(nprev)
	smid=(spart1+spart2)/2.

	dxunit=0
	dyunit=0
	do inode=1,nprev
		sss=sprev(inode)
		d_value=cos( (pi / (spart2-spart1)) * (sss-smid) )
		dxunit(inode)= - d_value * dyds
		dyunit(inode)=   d_value * dxds
		!write(*,*)' sss=',sss,' d_value=',d_value
	end do
	
	xray = xprev - dxunit * bend_cur * sign
	yray = yprev - dyunit * bend_cur * sign
	nray=nprev

	!write(*,*)' nray=',nray

	call remeshing(1,nray,step)

	!write(*,*)' nray=',nray

	do i=1,nray
		x=xray(i)
		y=yray(i)
		vray(i)=velocity(x,y)
	end do

	tray=0
	do inod=2,nray
		s1=sray(inod-1)
		s2=sray(inod)
		v1=vray(inod-1)
		v2=vray(inod)
		ds=s2-s1
		vm=(v2+v1)/2.
		tray=tray+ds/vm
		!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
	end do
	!write(*,*)' bend_cur=',bend_cur,' tray=',tray

	!write(42,*)nray
	!do i=1,nray
	!	write(42,*)xray(i),yray(i)
	!end do

	xprev=xray
	yprev=yray
	sprev=sray
	vprev=vray
	tprev=tray
	nprev=nray

end do
!close(42)


449 continue
nray=nprev
tray=tprev
xray=xprev
yray=yprev
vray=vprev
sray=sprev


bend_cur=bendreg_max/2.
tmin=tray


!open(42,file='../../FIG_files/rays/ini_all3.bln')


243 continue

spart1=0
spart2=sprev(nprev)
smid=(spart1+spart2)/2.

dxunit=0
dyunit=0
do inode=1,nprev
	sss=sprev(inode)
	d_value=cos( (pi / (spart2-spart1)) * (sss-smid) )
	dxunit(inode)= - d_value * dyds
	dyunit(inode)=   d_value * dxds
	!write(*,*)' sss=',sss,' d_value=',d_value
end do

isign=1


241 continue

xray = xprev - dxunit * bend_cur * isign
yray = yprev - dyunit * bend_cur * isign
nray=nprev

!write(*,*)' nray=',nray

call remeshing(1,nray,step)

!write(*,*)' nray=',nray

do i=1,nray
	x=xray(i)
	y=yray(i)
	vray(i)=velocity(x,y)
end do

tray=0
do inod=2,nray
	s1=sray(inod-1)
	s2=sray(inod)
	v1=vray(inod-1)
	v2=vray(inod)
	ds=s2-s1
	vm=(v2+v1)/2.
	tray=tray+ds/vm
	!write(*,*)' s2=',s2,' vm=',vm,' t=',tray
end do
!write(*,*)' bend_cur=',bend_cur,' isign=',isign,' tray=',tray,tmin

!write(42,*)nray
!do i=1,nray
!	write(42,*)xray(i),yray(i)
!end do


if(tray.lt.tmin) then
	xprev=xray
	yprev=yray
	sprev=sray
	vprev=vray
	tprev=tray
	nprev=nray
	tmin=tprev
	!write(*,*)' success: tmin=',tmin
	!open(47,file='../../FIG_files/rays/ray_cur.bln')
	!write(47,*)nray
	!do i=1,nray
	!	write(47,*)xray(i),yray(i)
	!end do
	!close(47)
else
	if(isign.eq.1) then
		isign=-1
		goto 241
	end if
end if

bend_cur=bend_cur/2
if(bend_cur.gt.bendreg_min) goto 243


nray=nprev
tray=tprev
xray=xprev
yray=yprev
vray=vprev
sray=sprev



!close(42)

!open(42,file='../../FIG_files/rays/ini_ray.bln')
!write(42,*)nray
!do i=1,nray
!	write(42,*)xray(i),yray(i)
!end do
!close(42)

!write(*,*)' tray=',tray

return
end